"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _assert = _interopRequireDefault(require("assert"));

var _fs = _interopRequireDefault(require("fs"));

var _mocha = require("mocha");

var _path = _interopRequireDefault(require("path"));

var _solidityParserAntlr = _interopRequireDefault(require("solidity-parser-antlr"));

var _printer = require("../lib/printer");

var _context;

const FIXTURE_PATH = _path.default.join(__dirname, "../", "../", "src", "test", "fixtures", "contracts");

const FIXTURES = (0, _map.default)(_context = _fs.default.readdirSync(FIXTURE_PATH)).call(_context, f => {
  const fp = _path.default.join(FIXTURE_PATH, f);

  return {
    basename: f,
    path: fp,
    source: _fs.default.readFileSync(fp, "utf8")
  };
});
(0, _mocha.describe)("Printer", () => {
  (0, _mocha.describe)("printing an AST", () => {
    (0, _mocha.describe)("prints equivalent code", () => {
      for (const fixture of FIXTURES) {
        (0, _mocha.it)(fixture.basename, () => {
          const astBefore = _solidityParserAntlr.default.parse(fixture.source, {
            loc: false,
            range: false
          });

          const printer = new _printer.Printer(astBefore);
          const source = printer.print();

          const astAfter = _solidityParserAntlr.default.parse(source, {
            loc: false,
            range: false
          }); // Remove .tokens from the AST as it gets walked and processed by
          // prettier. This is not consequential for anything else. Also, the
          // tokens property is added without types, and as we can't remove it
          // without Typescript doing some type checks, we'll have to ask it to
          // ignore those here.
          //
          // @ts-ignore


          delete astBefore.tokens;

          _assert.default.deepEqual(astBefore, astAfter);
        });
      }
    });
  });
});
//# sourceMappingURL=printer.spec.js.map